from machine import Pin
from time import sleep

pin1 = Pin(16, Pin.OUT)   #PINES DE CONEXION DEL MODULO ESP8266 CON EL DRIVER ULN2003
pin2 = Pin(5,  Pin.OUT)
pin3 = Pin(4,  Pin.OUT)
pin4 = Pin(0,  Pin.OUT) 

tiempo = 0.005
#tiempo = 0.5

WaveDrive=[
  [1,0,0,0],
  [0,1,0,0],          
  [0,0,1,0],
  [0,0,0,1]]              #SECUENCIA DE ONDA 

FullStepDrive=[
  [1,0,0,1],
  [1,1,0,0],
  [0,1,1,0],
  [0,0,1,1]]               #SECUENCIA DE PASO COMPLETO

HalfStepDrive=[
  [1,0,0,1],
  [1,0,0,0],
  [1,1,0,0],
  [0,1,0,0],
  [0,1,1,0],
  [0,0,1,0],
  [0,0,1,1],
  [0,0,0,1]]                #SECUENCIA DE MEDIO PASO
  
#Secuencias sentido de giro HORARIO
#===============================================================================

def secuenciaWaveDrive_horario(tiempo):
  for indice in range(2048):
    pin1.value(WaveDrive[indice%4][3])
    pin2.value(WaveDrive[indice%4][2])
    pin3.value(WaveDrive[indice%4][1])
    pin4.value(WaveDrive[indice%4][0])
    sleep(tiempo)
    
def secuenciaFullStepDrive_horario(tiempo):
  for indice in range(2048):
    pin1.value(FullStepDrive[indice%4][3])
    pin2.value(FullStepDrive[indice%4][2])
    pin3.value(FullStepDrive[indice%4][1])
    pin4.value(FullStepDrive[indice%4][0])
    sleep(tiempo)
           
def secuenciaHalfStepDrive_horario(tiempo):
  for indice in range(4096):
    pin1.value(HalfStepDrive[indice%8][3])
    pin2.value(HalfStepDrive[indice%8][2])
    pin3.value(HalfStepDrive[indice%8][1])
    pin4.value(HalfStepDrive[indice%8][0])
    sleep(tiempo)        
      
#Secuencias sentido de giro AHORARIO    
#===============================================================================    
def secuenciaWaveDrive_Ahorario(tiempo):
  for indice in range(2048):
    pin1.value(WaveDrive[indice%4][0])
    pin2.value(WaveDrive[indice%4][1])
    pin3.value(WaveDrive[indice%4][2])
    pin4.value(WaveDrive[indice%4][3])
    sleep(tiempo)
    
def secuenciaFullStepDrive_Ahorario(tiempo):
  for indice in range(2048):
    pin1.value(FullStepDrive[indice%4][0])
    pin2.value(FullStepDrive[indice%4][1])
    pin3.value(FullStepDrive[indice%4][2])
    pin4.value(FullStepDrive[indice%4][3])
    sleep(tiempo)
           
def secuenciaHalfStepDrive_Ahorario(tiempo):
  for indice in range(4096):
    pin1.value(HalfStepDrive[indice%8][0])
    pin2.value(HalfStepDrive[indice%8][1])
    pin3.value(HalfStepDrive[indice%8][2])
    pin4.value(HalfStepDrive[indice%8][3])
    sleep(tiempo)  
      
#===============================================================================    
def secuenciaParo():
  pin1.value(0)
  pin2.value(0)
  pin3.value(0)
  pin4.value(0)
  sleep(tiempo) 
  
#===============================================================================    
def main():
  secuenciaWaveDrive_horario(tiempo)
  secuenciaWaveDrive_Ahorario(tiempo)   #GIRO COMPLETO
  
  secuenciaFullStepDrive_horario(tiempo)
  secuenciaFullStepDrive_Ahorario(tiempo)  #GIRO COMPLETO
  
  secuenciaHalfStepDrive_horario(tiempo/2)
  secuenciaHalfStepDrive_Ahorario(tiempo/2)  #GIRO COMPLETO
  
  secuenciaParo()
  
#=============================================================================== 
main()

#=============================================================================== 
